/*
############################################################################
# This file contains the word functions for the pfth Forth interpreter.
#
# Copyright (c) 2012 Dave Hein
# MIT Licensed
############################################################################
*/
#include <propeller.h>

int errorcode;

int fetchoutafunc(void *parm)
{
    push(OUTA);
    return errorcode;
}

int storeoutafunc(void *parm)
{
    OUTA = pop();
    return errorcode;
}

int fetchdirafunc(void *parm)
{
    push(DIRA);
    return errorcode;
}

int storedirafunc(void *parm)
{
    DIRA = pop();
    return errorcode;
}

int setoutafunc(void *parm)
{
    OUTA |= pop();
    return errorcode;
}

int clroutafunc(void *parm)
{
    OUTA &= ~pop();
    return errorcode;
}

int setdirafunc(void *parm)
{
    DIRA |= pop();
    return errorcode;
}

int clrdirafunc(void *parm)
{
    DIRA &= ~pop();
    return errorcode;
}

int cntfunc(void *parm)
{
    push(CNT);
    return errorcode;
}

void InitializePropWords()
{
    MakeEntry("outa!", storeoutafunc, 0);
    MakeEntry("outa@", fetchoutafunc, 0);
    MakeEntry("dira!", storedirafunc, 0);
    MakeEntry("dira@", fetchdirafunc, 0);
    MakeEntry("setouta", setoutafunc, 0);
    MakeEntry("clrouta", clroutafunc, 0);
    MakeEntry("setdira", setdirafunc, 0);
    MakeEntry("clrdira", clrdirafunc, 0);
    MakeEntry("cnt", cntfunc, 0);
}
/*
+--------------------------------------------------------------------
|  TERMS OF USE: MIT License
+--------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+------------------------------------------------------------------
*/
